// ICON
//
// ---------------------------------------------------------------
// Copyright (C) 2004-2025, DWD, MPI-M, DKRZ, KIT, ETH, MeteoSwiss
// Contact information: icon-model.org
//
// See AUTHORS.TXT for a list of authors
// See LICENSES/ for license information
// SPDX-License-Identifier: BSD-3-Clause
// ---------------------------------------------------------------
#pragma once

#include "mo_lib_loopindices.hpp"
#include <Kokkos_Core.hpp>
#include <vector>

template <typename T, typename S>
void rbf_vec_interpol_vertex_lib(
    const T *p_e_in, const int *rbf_vec_idx_v, const int *rbf_vec_blk_v,
    const T *rbf_vec_coeff_v, S *p_u_out, S *p_v_out, const int i_startblk,
    const int i_endblk, const int i_startidx_in, const int i_endidx_in,
    const int slev, const int elev, const int nproma, const bool lacc,
    const bool acc_async, const int nlev, const int nblks_e, const int nblks_c);

template <typename T>
void rbf_interpol_c2grad_lib(const T *p_cell_in, const int *rbf_c2grad_idx,
                             const int *rbf_c2grad_blk,
                             const T *rbf_c2grad_coeff, T *grad_x, T *grad_y,
                             int i_startblk, int i_endblk, int i_startidx_in,
                             int i_endidx_in, int slev, int elev, int nproma,
                             int rbf_c2grad_dim, int nlev, int nblks_c,
                             bool lacc);

template <typename T>
void rbf_vec_interpol_cell_lib(const T *p_vn_in, const int *rbf_vec_idx_c,
                               const int *rbf_vec_blk_c,
                               const T *rbf_vec_coeff_c, T *p_u_out, T *p_v_out,
                               int i_startblk, int i_endblk, int i_startidx_in,
                               int i_endidx_in, int slev, int elev, int nproma,
                               int nlev, int nblks_c, int nblks_e,
                               int rbf_vec_dim_c, bool lacc, bool acc_async);

template <typename T>
void rbf_vec_interpol_edge_lib(const T *p_vn_in, const int *rbf_vec_idx_e,
                               const int *rbf_vec_blk_e,
                               const T *rbf_vec_coeff_e, T *p_vt_out,
                               int i_startblk, int i_endblk, int i_startidx_in,
                               int i_endidx_in, int slev, int elev, int nlev,
                               int nproma, int rbf_vec_dim_e, int nblks_e,
                               bool lacc, bool acc_async);
