// ICON
//
// ---------------------------------------------------------------
// Copyright (C) 2004-2025, DWD, MPI-M, DKRZ, KIT, ETH, MeteoSwiss
// Contact information: icon-model.org
//
// See AUTHORS.TXT for a list of authors
// See LICENSES/ for license information
// SPDX-License-Identifier: BSD-3-Clause
// ---------------------------------------------------------------
#pragma once

extern "C" {
    // mo_loop_indices.F90
    void get_indices_c_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
                            int &i_startidx_out, int &i_endidx_out);

    void get_indices_e_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
                            int &i_startidx_out, int &i_endidx_out);

    void get_indices_v_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
                            int &i_startidx_out, int &i_endidx_out);

    //mo_math_utilities.F90
    void tdma_solver_vec_dp(const double* a, const double* b, const double* c, const double* d,
        int slev, int elev, int startidx, int endidx,
        int nrows, int ncols, double* varout);

    void tdma_solver_vec_sp(const float* a, const float* b, const float* c, const float* d,
          int slev, int elev, int startidx, int endidx,
          int nrows, int ncols, float* varout);

}
